<template>
    <div class="loanStatus" @mouseover="hover = true" @mouseleave="hover = false" @focus="hover = true" @blur="hover = false">
        <div class="loanStatus__wrapper">
            <div :class="[statusClass]" class="status">
                <div>
                    <SVGIcon :xlink="xlink" :fill="fill" viexBox="0 0 20 20"></SVGIcon>
                    <span :class="{'text-fin-def': finProtection}" style="position: relative; top: -6px;">{{statusText}}</span>
                </div>
                <div class="block-fin-def-day" v-if="finProtection">
                    ДЕНЬ {{$pdl.supplementary.finProtection.dayPassed}} из {{$pdl.supplementary.finProtection.duration}}
                </div>
            </div>

            <transition name="fade">
                <div class="tooltip" v-show="tooltip">
                <span class="close">
                    <SVGIcon xlink="close-45" viewBox="0 0 45 45" :fill="$theme.colors.gray" class="close"
                             @click.native="hover = false;"></SVGIcon>
                </span>
                    <span class="text">
                    Финансовая защита — это отсрочка платежа на 15 дней без ухудшения кредитной истории, а также отмена процентов по займу до 15 дней в случае потери работы.
               </span>
                </div>
            </transition>
        </div>
    </div>
</template>

<script>
import SVGIcon from '@/components/SVGIcon';
export let dateFormat = (date) => {
    let ua = navigator.userAgent.toLowerCase()

    return /firefox/i.test(ua) // For Firefox browser
        ? date
        : date.replace(/-/g, '/').replace(/T/g, ' ')
}
export default {
    name: 'loan-status',
    components: {
        SVGIcon
    },
	data() {
		return {
			tooltip: false,
            hover: false,
		};
	},
    computed: {

        expired() {
            return this.$pdl.overdue ? '-overdue' : '';
        },

        statusClass() {
            return `status-${this.$pdl.status}${this.expired}`;
        },

        finProtection () {
			/**
             * Финансовая защита - статус в приорете всех остальных, на момент, пока она действует
             * в случае просрочки, отменяет все действия на указания просрочки
			 */
			return this.$pdl.status === 6 && this.$pdl.supplementary?.finProtection?.status === 'active'
        },
        statusText() {
			if (this.finProtection) {
				return 'Финансовая защита'
			}
            if (this.$pdl.status === 6 && this.expired) {
                const now = this.$dayjs(new Date());
                const day = this.$dayjs(this.$pdl.supplementary?.loanNewDateEnd  || this.$pdl.dateTo);
                const difference = Math.ceil(now.diff(day.format('YYYY-MM-DD'), 'second') / 86400);

                return `Займ просрочен на ${difference} ${this.$helpers.plural(difference, ['день', 'дня', 'дней'])}`
            }
            return this.$pdl.statusText;
        },

        fill() {
        	if (this.finProtection) {
                return this.$theme.colors.statusGreen
        	}
            switch (this.$pdl.status) {
                case 1:
                case 2:
                case 3:
                case 4:
                    return this.$theme.colors.statusAwait;
                case 5:
                    return this.$theme.colors.statusGreen;

                case 6:
                    return this.expired ? this.$theme.colors.statusRed : this.$theme.colors.statusGreen;
                case 100:
                    return this.$theme.colors.statusRed;
            }
        },

        xlink() {
			if (this.finProtection) {
				if (this.hover) {
					return 'fin-protection-20-hover'
				}
				return 'fin-protection-20'
			}
            return `status-${this.$pdl.status}${this.expired}`;
        }
    },
	watch: {
		hover (hover) {
			if(this.finProtection) {
				this.tooltip = hover;
			}
		}
	},

};
</script>

<style lang="scss">
    @import "static/css/variables/color";

    .status-6-overdue {
        color: $redDark;
        font-weight: bold;
    }
    .block-fin-def-day {
        /*width: 103px;*/
        padding: 0 10px;
        height: 25px;
        border-radius: 5px;
        background-color: #dceddc;
        letter-spacing: 1px;
        color: #51a351;
        font-family: Roboto;
        font-size: 11px;
        font-weight: normal;
        font-style: normal;
        font-stretch: normal;
        margin-left: 20px;
        text-align: center;
        line-height: 25px
    }
    .text-fin-def {
        font-family: Roboto;
        font-size: 17px;
        font-weight: 500;
        font-style: normal;
        font-stretch: normal;
        line-height: 1.33;
        letter-spacing: normal;
        color: #51a351;
    }
</style>
